Add retry function to pkg install phase
Related-Prod: PRODX-2063
Change-Id: Ib31c8485caa30dc1e382436f855f00e23056d4aa
diff --git a/de/heat-templates/scripts/instance_boot.sh b/de/heat-templates/scripts/instance_boot.sh
index 54eed58..b48ff49 100644
--- a/de/heat-templates/scripts/instance_boot.sh
+++ b/de/heat-templates/scripts/instance_boot.sh
@@ -16,6 +16,29 @@
UCP_MASTER_HOST=$ucp_master_host
UCP_MASTER_HOST=${UCP_MASTER_HOST:-${NODE_IP_ADDRESS}}
+function retry {
+ local retries=$1
+ shift
+ local msg="$1"
+ shift
+
+ local count=0
+ until "$@"; do
+ exit=$?
+ wait=$((2 ** $count))
+ count=$(($count + 1))
+ if [ $count -lt $retries ]; then
+ echo "Retry $count/$retries exited $exit, retrying in $wait seconds..."
+ sleep $wait
+ else
+ echo "Retry $count/$retries exited $exit, no more retries left."
+ echo "$msg"
+ return $exit
+ fi
+ done
+ return 0
+}
+
function wait_condition_send {
local status=${1:-SUCCESS}
local reason=${2:-empty}
@@ -39,11 +62,14 @@
}
function install_docker_ce {
- apt install -y apt-transport-https ca-certificates curl software-properties-common
- curl --retry 6 --retry-delay 5 -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo apt-key add -
- add-apt-repository "deb [arch=amd64] https://download.docker.com/linux/ubuntu ${OS_CODENAME} stable"
- apt-get update
- apt-get install -y docker-ce jq unzip
+ function install_retry {
+ apt install -y apt-transport-https ca-certificates curl software-properties-common
+ curl --retry 6 --retry-delay 5 -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo apt-key add -
+ add-apt-repository "deb [arch=amd64] https://download.docker.com/linux/ubuntu ${OS_CODENAME} stable"
+ apt update
+ apt install -y docker-ce jq unzip
+ }
+ retry 10 "Failed to install docker CE" install_retry
}
function update_docker_network {